質問をすることでしか得られない、回答やアドバイスがある。

15分調べてもわからないことは、質問しよう!

ただいまの
回答率

90.00%

PHP7でPECL-Perlが使えない

受付中

回答 2

投稿 編集

  • 評価
  • クリップ 0
  • VIEW 1,994

eyeye

score 6

前提・実現したいこと

PHPからPerlを呼び出すため、PECL-Perl 1.0.1を使用していたのですが、
PHP5.6からPHP7.0.12にアップグレード後、使えなくなりました。

PECL-Perl
https://pecl.php.net/package/perl

再度PECL-Perl 1.0.1をソースからインストールし直し、
php.iniにextension=perl.soを追加しましたが、logに下記のerrorで動きません。

[error] 28622#28622: *273 FastCGI sent in stderr: "PHP message: PHP Fatal error:  Uncaught Error: Class 'Perl' not found in 

PHP7での使用は不可能でしょうか?
PHPからPerlを呼び出す必要があるため、ご教授お願いいたします。

発生している問題・エラーメッセージ

php-fpm -v
[21-Oct-2016 04:59:21] NOTICE: PHP message: PHP Warning:  PHP Startup: Unable to load dynamic library '/usr/lib64/php/modules/perl.so' - /usr/lib64/php/modules/perl.so: undefined symbol: zval_used_for_init in Unknown on line 0
PHP 7.0.12 (fpm-fcgi) (built: Oct 13 2016 18:03:58)
Copyright (c) 1997-2016 The PHP Group
Zend Engine v3.0.0, Copyright (c) 1998-2016 Zend Technologies

試したこと

インストールは以下を参考にインストールしました。
https://askubuntu.com/questions/245996/unable-to-install-pecl-extension-for-perl-in-ubuntu-server-12-10/248858

補足情報(言語/FW/ツール等のバージョンなど)

CentOS 7.2.1511
Nginx 1.10.2

  • 気になる質問をクリップする

    クリップした質問は、後からいつでもマイページで確認できます。

    またクリップした質問に回答があった際、通知やメールを受け取ることができます。

    クリップを取り消します

  • 良い質問の評価を上げる

    以下のような質問は評価を上げましょう

    • 質問内容が明確
    • 自分も答えを知りたい
    • 質問者以外のユーザにも役立つ

    評価が高い質問は、TOPページの「注目」タブのフィードに表示されやすくなります。

    質問の評価を上げたことを取り消します

  • 評価を下げられる数の上限に達しました

    評価を下げることができません

    • 1日5回まで評価を下げられます
    • 1日に1ユーザに対して2回まで評価を下げられます

    質問の評価を下げる

    teratailでは下記のような質問を「具体的に困っていることがない質問」、「サイトポリシーに違反する質問」と定義し、推奨していません。

    • プログラミングに関係のない質問
    • やってほしいことだけを記載した丸投げの質問
    • 問題・課題が含まれていない質問
    • 意図的に内容が抹消された質問
    • 広告と受け取られるような投稿

    評価が下がると、TOPページの「アクティブ」「注目」タブのフィードに表示されにくくなります。

    質問の評価を下げたことを取り消します

    この機能は開放されていません

    評価を下げる条件を満たしてません

    評価を下げる理由を選択してください

    詳細な説明はこちら

    上記に当てはまらず、質問内容が明確になっていない質問には「情報の追加・修正依頼」機能からコメントをしてください。

    質問の評価を下げる機能の利用条件

    この機能を利用するためには、以下の事項を行う必要があります。

回答 2

+3

PECL  : 2013-01-23
PHP 7 : 2015-12-03

ですのでメジャーバージョンアップしたPHP7には非対応でしょう

大抵 NEWER / LETER 等それ以降を表すものはメジャーアップデートの対象ではありません。
現状 5.6 のほうが 7.0 よりセキュリティパッチの更新が長いので 5.6 にしてください。

ちなみに system で呼び出しは可能なはずです。(戻り値を別の方法で受け取りましょう)

投稿

編集

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2016/10/21 18:50

    system以外にもshell_exec,exec,popen,proc_open,pcntl_execなど選択肢はいくつかあります。

    キャンセル

  • 2016/10/21 21:09

    mpyw そこら辺はほら リンク先のドキュメントにもかいてあるし(・q・

    キャンセル

  • 2016/10/22 14:36 編集

    あ,いや,戻り値を受け取るという前提ならsystemは選択肢から外れるかなと…(それ以外の深い意味は無いです

    といいつつpcntl_execもダメですね…失礼しました

    キャンセル

  • 2016/10/22 14:58 編集

    ラスト1行が取得が可能だから十分使えると思うが。
    テンプレート出力に使う場合はNGかしら?

    キャンセル

+2

php7 では、下位互換性のない変更点が色々とありますので、これらの機能を使っている場合は動作しないと思います。
http://php.net/manual/ja/migration70.php

php7のβ版が出た頃は、imagick等のモジュールでも動かないのが多かったのですが、各モジュールがphp7に対応することで、動くようになりました。

pecl-perl が、3年間更新されていないので、php7 に対応していないのだと思います。

投稿

  • 回答の評価を上げる

    以下のような回答は評価を上げましょう

    • 正しい回答
    • わかりやすい回答
    • ためになる回答

    評価が高い回答ほどページの上位に表示されます。

  • 回答の評価を下げる

    下記のような回答は推奨されていません。

    • 間違っている回答
    • 質問の回答になっていない投稿
    • スパムや攻撃的な表現を用いた投稿

    評価を下げる際はその理由を明確に伝え、適切な回答に修正してもらいましょう。

  • 2016/10/21 07:59

    zend_value(zval)回りを大幅に変更していますしね

    キャンセル

15分調べてもわからないことは、teratailで質問しよう!

  • ただいまの回答率 90.00%
  • 質問をまとめることで、思考を整理して素早く解決
  • テンプレート機能で、簡単に質問をまとめられる